module top_uart_fifo(
	User_mode_start,
	User_add,
	Enable,
//     Mem_Sel,
     LED,
	  
      A,
	IO_0,
	IO_1,
	
	CE_0,
	CE_1,
	
	WE,
	OE,
	
	LB_0,
	LB_1,
	
	UB_0,
	UB_1,

	RESETn,        // active-low power-up reset == ifp_resetb
    CLOCK,         // system clock == ifp_clk == iwp_clk
    UART_TX1,
UART_RX1);

input wire User_mode_start; // 
input wire [1:0] User_add; // 

input CLOCK; //
input RESETn; //
 
input wire Enable; // 
//input wire [1:0] Mem_Sel; // 

output wire [7:0] LED; // 

output wire [17:0] A;  // 

inout wire [15:0] IO_0; // 
inout wire [15:0] IO_1; // 

output wire CE_0; // 
output wire CE_1; //

output wire WE; //
output wire OE; // 

output wire LB_0; //
output wire LB_1; //

output wire UB_0; // 
output wire UB_1; // 

output wire UART_TX1; //
input wire UART_RX1; // 

//////////////////////////////////////////////////////
wire [15:0] boardmem_dat_o_0;
wire [15:0] boardmem_dat_o_1;

wire [15:0] boardmem_dat_i_0;
wire [15:0] boardmem_dat_i_1;

wire [2:0] uart_addr_o;
wire [7:0] uart_wdata_o; // write to reg
wire [7:0] uart_rdata_i; // read from reg
wire uart_we_o; // Write enable for registers
wire uart_re_o; // Read enable for registers

wire interrupt;
wire   rtsn;
wire   ctsn = 1'b0;
wire   dtr_pad_o;
wire   dsr_pad_i=1'b0;
wire   ri_pad_i =1'b0;
wire   dcd_pad_i=1'b0;
//--------------------------------------------------------
wire       rts_internal;
wire 		PCLK;
assign     rtsn = ~rts_internal;

assign IO_0 =  WE? 16'bz : boardmem_dat_o_0 ;  // WE_o is low active (writing is low active)
assign boardmem_dat_i_0 = WE?  IO_0 : 16'bz ;  // WE_O value is 1 in case of  reading status

assign IO_1 =  WE? 16'bz : boardmem_dat_o_1 ;  // WE_o is low active (writing is low active)
assign boardmem_dat_i_1 = WE?  IO_1 : 16'bz ;  // WE_O value is 1 in case of  reading status

reg half_clk;
   // synopsys translate_off
   initial half_clk <= 1'b0;
   // synopsys translate_on
   always @(posedge CLOCK) half_clk <= ~half_clk;
	BUFG UBUF(.I(half_clk), .O(PCLK));
	
board_fifo Uboard_fifo (
	.User_mode_start(User_mode_start), 
	.User_add(User_add),
	.Enable(Enable), 
//	.Mem_Sel(Mem_Sel), 
	.CLK(PCLK), 
	.RSTn(RESETn), 
	.LED(LED), 
	.boardmem_addr_o(A), 
	//.boardmem_dat_0(IO_0), 
	//.boardmem_dat_1(IO_1), 
	.boardmem_dat_o_0(boardmem_dat_o_0),
	.boardmem_dat_o_1(boardmem_dat_o_1),
	.boardmem_dat_i_0(boardmem_dat_i_0),
	.boardmem_dat_i_1(boardmem_dat_i_1),
	.CE_o_0(CE_0), 
	.CE_o_1(CE_1), 
	.WE_o(WE), 
	.OE_o(OE),
	.LB_o_0(LB_0), 
	.LB_o_1(LB_1), 
	.UB_o_0(UB_0), 
	.UB_o_1(UB_1), 
	.uart_addr_o(uart_addr_o), 
	.uart_wdata_o(uart_wdata_o), 
	.uart_rdata_i(uart_rdata_i), 
	.uart_we_o(uart_we_o), 
	.uart_re_o(uart_re_o)
);
 
/*
board_fifo Uboard_fifo (
	.User_mode_start(User_mode_start), 
	.User_add(User_add),
	.Enable(Enable), 
//	.Mem_Sel(Mem_Sel), 
	.CLK(CLOCK), 
	.RSTn(RESETn), 
	.LED(LED), 
	.boardmem_addr_o(A_temp), 
	//.boardmem_dat_0(boardmem_dat_0),
	//.boardmem_dat_1(boardmem_dat_1),
	.boardmem_dat_o_0(boardmem_dat_o_0),
	.boardmem_dat_o_1(boardmem_dat_o_1),
	.boardmem_dat_i_0(boardmem_dat_i_0),
	.boardmem_dat_i_1(boardmem_dat_i_1),
	.CE_o_0(CE_0_temp), 
	.CE_o_1(CE_1_temp), 
	.WE_o(WE_temp), 
	.OE_o(OE_temp),
	.LB_o_0(LB_0_temp), 
	.LB_o_1(LB_1_temp), 
	.UB_o_0(UB_0_temp), 
	.UB_o_1(UB_1_temp), //
	.uart_addr_o(uart_addr_o), 
	.uart_wdata_o(uart_wdata_o), 
	.uart_rdata_i(uart_rdata_i), 
	.uart_we_o(uart_we_o), 
	.uart_re_o(uart_re_o)
);
*/
 uart_regs Uregs(
          .clk         (PCLK),
          .wb_rst_i    (~RESETn),
          .wb_addr_i   (uart_addr_o),
          .wb_dat_i    (uart_wdata_o),
          .wb_dat_o    (uart_rdata_i),
          .wb_we_i     (uart_we_o),
          .wb_re_i     (uart_re_o),
          .modem_inputs({~ctsn, dsr_pad_i, ri_pad_i,  dcd_pad_i}),
          .stx_pad_o   (UART_TX1),
          .srx_pad_i   (UART_RX1),
          .rts_pad_o   (rts_internal),
          .dtr_pad_o   (dtr_pad_o),
          .int_o       (interrupt)
  );

endmodule





