module transition(transition_enable,uart_rdata_i, transition_data_o);
input wire transition_enable;
input wire [7:0] uart_rdata_i;
output reg [3:0] transition_data_o;

always @(transition_enable or uart_rdata_i)
begin
	if(transition_enable == 1'b1) begin
	case(uart_rdata_i)
		8'h30 : begin
			transition_data_o <= 4'h0;
		end
		8'h31 : begin
			transition_data_o <= 4'h1;
		end
		8'h32 : begin
			transition_data_o <= 4'h2;
		end
		8'h33 : begin
			transition_data_o <= 4'h3;
		end
		8'h34 : begin
			transition_data_o <= 4'h4;
		end
		8'h35 : begin
			transition_data_o <= 4'h5;
		end
		8'h36 : begin
			transition_data_o <= 4'h6;
		end
		8'h37 : begin
			transition_data_o <= 4'h7;
		end
		8'h38 : begin
			transition_data_o <= 4'h8;
		end
		8'h39 : begin
			transition_data_o <= 4'h9;
		end
		8'h61 : begin
			transition_data_o <= 4'ha;
		end
		8'h62 : begin
			transition_data_o <= 4'hb;
		end
		8'h63 : begin
			transition_data_o <= 4'hc;
		end
		8'h64 : begin
			transition_data_o <= 4'hd;
		end
		8'h65 : begin
			transition_data_o <= 4'he;
		end
		8'h66 : begin
			transition_data_o <= 4'hf;
		end
		default : begin
			transition_data_o <= 4'bzzzz;
		end
	endcase
end
	else  begin
	transition_data_o <= 4'bzzzz;
	end
end

endmodule
